package producetracker;

import java.util.Iterator;
import java.util.TreeMap;

public class Inventory {
    
    private TreeMap<String,Item> stock;
    
    private Item find(String name) {
        return stock.get(name);
    }
    
    private boolean exists(String name) {
        return stock.containsKey(name);
    }
    
    public Inventory() {
        stock = new TreeMap<String,Item>();
    }
    
    public void addItems(String name,int howMany) {
        // When some items come in, we first need to see if those items
        // are already in our stock list
        if(exists(name)) {
            Item existingItem = find(name);
            existingItem.increaseQuantity(howMany);
        } else {
            Item newItem = new Item(name);
            newItem.increaseQuantity(howMany);
            stock.put(name,newItem);
        }
    }
    
    public void removeItems(String item,int howMany) {
        Item existingItem = find(item);
        existingItem.decreaseQuantity(howMany);
        if(existingItem.isNoneLeft()) {
            stock.remove(item);
        }
    }
    
    public void printReport() {
        Iterator<Item> iter = stock.values().iterator();
        while(iter.hasNext()) {
            Item i = iter.next();
            System.out.println(i);
        }
    }
}
