package set_examples;

import java.io.File;
import java.util.Iterator;
import java.util.Scanner;
import java.util.TreeSet;

public class CompareFiles {
    public static void main(String[] args) {
        // Read the first set of numbers
        Scanner input = null;
        try {
            input = new Scanner(new File("one.txt"));
        } catch (Exception ex) {
            ex.printStackTrace();
            System.exit(0);
        }

        TreeSet<Integer> setOne = new TreeSet<Integer>();
        while (input.hasNextInt()) {
            int n = input.nextInt();
            if(setOne.add(n) == false)
                System.out.println("Duplicate in set one: " + n);
        }
        input.close();
        
        // Now read the second group of numbers, and add them
        // to a second set.
        try {
            input = new Scanner(new File("two.txt"));
        } catch (Exception ex) {
            ex.printStackTrace();
            System.exit(0);
        }

        TreeSet<Integer> setTwo = new TreeSet<Integer>();
        while (input.hasNextInt()) {
            int n = input.nextInt();
            if(setTwo.add(n) == false)
                System.out.println("Duplicate in set two: " + n);
        }
        input.close();
        
        // Now compare the two sets.
        if(setOne.size() != setTwo.size())
            System.out.println("The two sets are not the same.");
        else {
            boolean same = true;
            Iterator<Integer> iterator = setOne.iterator();
            while(iterator.hasNext()) {
                int x = iterator.next();
                if(!setTwo.contains(x)) {
                    same = false;
                    break;
                }
            }
            if(same == true)
                System.out.println("The two lists are the same.");
            else
                System.out.println("The two sets are different.");
            
        }
    }
}
