package set_examples;

import java.io.File;
import java.util.Iterator;
import java.util.Scanner;
import java.util.TreeSet;

/** Example program: given two files containing two lists of integers, figure
 *  out what numbers the two files have in common.
 */
public class SortedIntersectionBySet {
    public static void main(String[] args) {
        // Read the second set of numbers
        Scanner input = null;
        try {
            input = new Scanner(new File("two.txt"));
        } catch (Exception ex) {
            ex.printStackTrace();
            System.exit(0);
        }

        TreeSet<Integer> set = new TreeSet<Integer>();
        while (input.hasNextInt()) {
            int n = input.nextInt();
            set.add(n);
        }
        input.close();
        
        // Now read the first group of numbers, and print the ones
        // that appeared in our set
        try {
            input = new Scanner(new File("one.txt"));
        } catch (Exception ex) {
            ex.printStackTrace();
            System.exit(0);
        }

        TreeSet<Integer> overlaps = new TreeSet<Integer>();
        while (input.hasNextInt()) {
            int n = input.nextInt();
            if(set.contains(n))
                overlaps.add(n);
        }
        input.close();
        
        System.out.println("The two sets have " + overlaps.size() + " numbers in common.");
        
        System.out.println("Here are the common numbers:");
        
        Iterator<Integer> iter = overlaps.iterator();
        while(iter.hasNext()) {
            System.out.println(iter.next());
        }
        
        /* We could also have printed these numbers with an enhanced for loop:
        for(Integer x : overlaps)
            System.out.println(x);
        */
    }    
}
